	;
	; This is a small utility that "counts" (up to 255)
	; how many times each byte is used in the specified memory range.
	;
	; It was used in the Nyan Cat demo to find unused bytes.
	;
	ORG $0500-2
	DW $0500
	
start_addr = $0600
end_addr = $FC00
	
ptr	= $E0

frq_table = $0400

	SEI
	STA $FF3F
	;
	LDA #$41			; "working" gray :-)
	STA $FF19
	;
	LDY #$00
	TYA
il1	STA frq_table,y			; clear the frequency table
	INY
	BNE il1
	;
	LDA #start_addr & 255		; point to start address
	STA ptr
	LDA #start_addr >> 8
	STA ptr+1
	;
ml1	LDA (ptr),y			; get next byte
	TAX
	LDA frq_table,x			; are we already at...
	CMP #$FF			; 255?
	BEQ overflow
	INC frq_table,x			; if not, "count" this instance
overflow
	INY
	BNE ml1
	;
	INC ptr+1
	LDA ptr+1
	CMP #end_addr >> 8		; stop when we reach the end address
	BNE ml1
	;
	LDA #$35			; green border = we're done
	STA $FF19			; results can be inspected in YAPE
	JMP *				; by looking at $0400
;[eof]