	;
	; Main part of "Nyan cat".
	;
	; Plays intro tune,
	; Plays digi + animates,
	; Fades out music,
	; Fades out graphics,
	; "Unpacks" and starts upscroller.
	;
	ORG $0800-2
	DW $0800
	
	; Color map for all 6 images.
	; There's only room for 1 color map!
	include "colors_hex.asm"
	
lum	= $D2
col	= $D4

start	SEI
	STA $FF3F
	;
	; ---
	;
s0	LDA #$CC		; fade out the "buffering" text
	CMP $FF1D
	BNE s0
	;
	LDX #$0D
fd0	LDA $03DA,x
	SEC
	SBC #$10
	BPL fd1
	LDA #$00
fd1	STA $03DA,x
	DEX
	BPL fd0
	;
	LDA $03DA
	BNE s0
	;
	; ---
	;
	JSR intro_vibes		; play intro vibes
	;
	LDX #$FF
	LDA $FF07
	AND #$40
	BEQ sncx
	LDX #$F7
sncx	CPX $FF1D		; sync to bottom of screen
	BNE sncx
	;
	LDA #$0D		; set colors
	STA $FF15
	STA $FF19
	;
	LDA #$3B		; turn graphics mode on
	STA $FF06
	;
	LDA $FF07		; PAL/NTSC friendly
	AND #$40
	ORA #$18		; multicolor
	STA $FF07
	;
	LDA $FF12
	AND #$03		; keep lowest 2 bits (sound)	
	ORA #$08		; $08 = $2000, $10 = $4000, etc.
	STA $FF12
	;
	LDA #$08		; color map at $0800
	STA $FF14
	;
	ASL a			; A = $10, address of IRQ: $0010
	STA $FFFE
	LDY #$00
	STY $FFFF
	STY $FF16
	;
	; --------------------
	;
	LDX #irq_digi_end - irq_digi
irqc2	LDA irq_digi,x		; copy digi IRQ
	STA $10,x
	DEX
	BPL irqc2
	;
	; --------------------
	;
	JSR digi_init
	;
	; --------------------
	;
	CLI
	;
mainloop
	;
	LDA #$CC
sync3	CMP $FF1D
	BCS sync3
	;        
	;DEC $FF19
	;
cnt	LDX #$00
	INX
	CPX #20			; a total of 20 frames
	BNE nowrap
	LDX #$00
nowrap	STX cnt+1
	;
	LDA frames,x
	TAY
	;
	LDA col01,y		; look up colors and set them to fix clashes
	STA $0800+76/4+64/8*40
	STA $0800+84/4+64/8*40
	LDA lum01,y
	STA $0C00+76/4+64/8*40
	STA $0C00+84/4+64/8*40
	;
	LDA col02,y
	STA $0800+92/4+80/8*40
	LDA lum02,y
	STA $0C00+92/4+80/8*40
	;
	LDA col03,y
	STA $0800+100/4+88/8*40
	LDA lum03,y
	STA $0C00+100/4+88/8*40
	;
	LDA col04,y
	STA $0800+72/4+58/8*40
	LDA lum04,y
	STA $0C00+72/4+58/8*40
	;
	LDA col05,y
	STA $0800+44/4+88/8*40
	STA $0800+44/4+88/8*40+1
	STA $0800+44/4+88/8*40+2
	LDA lum05,y
	STA $0C00+44/4+88/8*40
	STA $0C00+44/4+88/8*40+1
	STA $0C00+44/4+88/8*40+2
	;
	LDA col06,y
	STA $0800+44/4+96/8*40
	LDA lum06,y
	STA $0C00+44/4+96/8*40
	;
	LDA col07,y
	STA $0800+48/4+96/8*40
	STA $0800+52/4+96/8*40
	LDA lum07,y
	STA $0C00+48/4+96/8*40
	STA $0C00+52/4+96/8*40
	;
	LDA col08,y
	STA $0800+44/4+112/8*40
	STA $0800+44/4+112/8*40+1
	LDA lum08,y
	STA $0C00+44/4+112/8*40
	STA $0C00+44/4+112/8*40+1
	;
	LDA col09,y
	STA $0800+44/4+112/8*40+2
	STA $0800+44/4+112/8*40+3
	LDA lum09,y
	STA $0C00+44/4+112/8*40+2
	STA $0C00+44/4+112/8*40+3
	;
	LDA col10,y
	STA $0800+56/4+128/8*40
	LDA lum10,y
	STA $0C00+56/4+128/8*40
	;
	LDA col11,y
	STA $0800+52/4+144/8*40
	LDA lum11,y
	STA $0C00+52/4+144/8*40
	;
	;INC $FF19
	;
	INY
	TYA
	ASL a			; *8 (bitmap address)
	ASL a
	ASL a
	STA tmp1+1
	;
	LDA $FF12
	AND #$03
tmp1	ORA #$00
	STA $FF12
	;       
	JSR DIGI_PLAYER
	;
	;DEC $FF19
vd0	BIT volume_down		; will become JSR
	;INC $FF19
	;
	LDA #$7F
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10		; Query keyboard for "Space"
	BNE space_not_pressed
	;
	LDA #$20		; opcode for JSR $0000
	STA vd0			; enable voldown code
	;
space_not_pressed
ml1	LDA $FF1D
	CMP #$CC
	BCS ml1
	;
	LDA WavBits
	CMP WavBits+$FF		; check if volume is completely down
	BEQ fade_out		; if so, start fadeout
	;
	JMP mainloop
fade_out
	SEI			; volume is completely down, stop digi
	;
	LDA #$00
	STA lum
	STA col
	;
z0	;LDA #$CC
	;CMP $FF1D
	;BNE *-3
	;DEC $FF19
	;
	LDA $FF15
	AND #$7F
	BEQ fo2
	SEC
	SBC #$10
	BPL fo1
	;
	LDA #$00
fo1	STA $FF15
	STA $FF19
fo2	;
	;
	LDY #$00
	;
	LDA #$08
	STA lum+1
	LDA #$0C
	STA col+1 
	;
z1	LDA (lum),y
	AND #$7F
	TAX
	LDA $BF40,x		; hardcoded...
	STA (lum),y
	;
	LDA (col),y
	AND $DF40,x		; hardcoded...
	STA (col),y
	;
	INY
	BNE z1
	;
	INC lum+1
	INC col+1
	LDA col+1
	CMP #$10
	BNE z1
	;
z2	;INC $FF19
	;
	LDA $0C00		; completely faded out?
	BNE z0
	;          
	LDX #decode_end-decode_beg	; relocate code (otherwise it would overwrite itself)
rel1	LDA decode_beg,x
	STA $0700,x
	DEX
	BPL rel1
	JMP $0700			; go to relocated code
	;
	; ---
	;
col01	DB $64,$64,$66,$66,$66,$66	; dots on back
lum01	DB $b4,$b4,$84,$84,$84,$84

col02	DB $65,$65,$64,$64,$64,$64	; dot near ear
lum02	DB $14,$14,$b4,$b4,$b4,$b4

col03	DB $56,$66,$66,$66,$66,$56	; between ears above head
lum03	DB $81,$84,$84,$84,$84,$81

col04	DB $66,$66,$66,$66,$76,$66	; star (5th frame)
lum04	DB $84,$84,$84,$84,$81,$84

	ALIGN 256
bass1_sample
	include "samples/fbass1.asm"
bass1_sample_end

	; color values for graphics screen
	;
	; AB, CD becomes: CA
	;                 BD

col05	DB $57,$67,$67,$67,$67,$67	; tail, line1
lum05	DB $71,$78,$78,$78,$78,$78

col06	DB $57,$57,$57,$57,$57,$57	; tail, line2
lum06	DB $7A,$71,$7A,$7A,$71,$71

col07	DB $57,$57,$57,$57,$57,$57	; tail
lum07	DB $71,$71,$7A,$7A,$71,$71

col08	DB $45,$45,$45,$55,$45,$45	; tail, line3
lum08	DB $AD,$AD,$1D,$A1,$AD,$AD

col09	DB $45,$55,$45,$45,$45,$55	; tail
lum09	DB $AD,$A1,$1D,$1D,$AD,$A1

col10	DB $45,$45,$25,$42,$45,$45	; tail, line4
lum10	DB $1D,$1D,$1E,$ED,$1D,$1D

col11	DB $72,$72,$72,$72,$75,$75	; hind leg
lum11	DB $E1,$E1,$E1,$E1,$11,$11

frames	
	DB 0,0,0,0,1,1,1,2,2,2
	DB 3,3,3,3,4,4,4,5,5,5

decode_beg
	include "decode_g0f00.asm"
decode_end
	;
volume_down
	LDX #$00
	LDY #$FE
vd1	LDA WavBits+1,x		; this loop had to be unrolled a bit
	STA WavBits,x		; to make it fit for NTSC
	LDA WavBits,y
	STA WavBits+1,y
	INX
	DEY
	;
	LDA WavBits+1,x
	STA WavBits,x
	LDA WavBits,y
	STA WavBits+1,y
	INX
	DEY
	;
	LDA WavBits+1,x
	STA WavBits,x
	LDA WavBits,y
	STA WavBits+1,y
	INX
	DEY
	;
	BMI vd1
	;
	RTS
	
intro_vibes
	;
	; --- this is an extremely fast and small music player :-)
	;
ivmain	LDA #$CC	; sync to frame
iv1	CMP $FF1D
	BNE iv1
iv2	CMP $FF1D
	BEQ iv2
	;
tick	LDX #9			; 10 frame long volume table (9 ensures it wraps immediately)
	INX
	CPX #10			; wrap at 10
	BNE iv3
	LDX #$00
iv3	STX tick+1
	;
	LDA volume_table,x
	STA $FF11		; look and set volume
	;
	CPX #$05		; play a note every 5 frames (x=5?)
	BEQ ivnote
	CPX #$00		; (x=0?) (txa, opcode $8A cannot be used)
	BNE ivmain
	;
ivnote	INC fp+1		; increment pointer
fp	LDA #$FF
	ASL a
	TAX
	LDA freq_table+1,x	; lookup freqs and write them directly to the TED regs
	BMI intro_done		; $FFFF flags end of tune
	STA $FF10
	LDA freq_table,x
	STA $FF0F
	;
	BNE ivmain
	;
intro_done
	RTS
	
freq_Di3 = $03A6
freq_E3  = $03AB
freq_F3  = $03B0
freq_Fi3 = $03B4
freq_G3  = $03B9
freq_Gi3 = $03BD
freq_A3  = $03C0
freq_Ai3 = $03C4
freq_B3  = $03C7
freq_C4  = $03CB
freq_Ci4 = $03CE
freq_D4  = $03D0
freq_Di4 = $03D3
freq_E4  = $03D6

volume_table
	DB $26,$26,$25,$25,$24,$24,$23,$23,$22,$22

freq_table	
	DW freq_Di3 		; 16 bit TED freq values stored directly
	DW freq_E3 
	DW freq_Fi3,freq_Fi3
	DW freq_B3,freq_B3
	DW freq_Di3 
	DW freq_E3 
	;
	DW freq_Fi3 
	DW freq_B3 
	DW freq_Ci4 
	DW freq_Di4 
	DW freq_Ci4 
	DW freq_B3 
	DW freq_Ci4 
	DW freq_Di4 
	;
	DW freq_Fi3,freq_Fi3 
	DW freq_Di3 
	DW freq_E3 
	DW freq_Fi3,freq_Fi3 
	DW freq_B3,freq_B3     
	;
	DW freq_Ci4 
	DW freq_B3 
	DW freq_Ci4 
	DW freq_Di4 
	DW freq_E4 
	DW freq_Di4 
	DW freq_Ci4 
	DW freq_B3 
	
	DW $FFFF		; end of music flag
	
	ORG $2000
	;
	; This file includes all 6 bitmaps,
	; The "upscroll" part encoded into them,
	; The fade out tables. 
	;
	include "new.asm"

WavBits
	include "digivalues.asm"
	include "digimusic.asm"
	include "digiplay.asm"
;[eof]