	;
	; This is meant to be used interactively in YAPE.
	; Load the program you want to compress, then load "pack"
	;
	; If the border turns RED, compression was unsuccessful.
	; Green means the data is ready to be saved (start/end are set).
	;
	ORG $0700-2
	DW  $0700

beg_	= $1800
end_	= $3F40
dest	= $7FFF
flags	= $0600

ptr	= $D0		; pointers
dst	= $2B

flag	= $E0		; vars
curr	= $E1
len	= $E2
	
start
	SEI
	STA $FF3F
	;
	LDA #$51
	STA $FF19
	;
	; --- clear flag area
	LDY #$00
	TYA
cl1	STA flags,y
	INY 
	BNE cl1
	;
	LDA #(dest+1) & 255
	STA $2D
	LDA #(dest+1) >> 8
	STA $2E
	;
	LDA #beg_ & 255
	STA ptr
	LDA #beg_ >> 8
	STA ptr+1
	;
	LDA (ptr),y		; make byte before first diff.
	PHA
	JSR dec_ptr
	PLA
	EOR #$55
	STA (ptr),y
	JSR inc_ptr
	;
	; ---
l1	LDA (ptr),y		; get one byte
	TAX
	LDA #$FF
	STA flags,x		; flag each used byte
	;
	JSR inc_ptr
	;
	LDA ptr			; at the end?
	CMP #end_ & 255
	BNE l1
	LDA ptr+1
	CMP #end_ >> 8
	BNE l1
	;
	; ---
	;
l2	LDA flags,y		; find first unused byte
	BPL found
	INY
	BNE l2	
	;
	LDA #$32		; no flag
	BNE stop		; always jump
	
found	STY flag		; found the flag, store it
	;
	; --- start compression
	;
	LDA #dest & 255		; start storing data from here
	STA dst
	LDA #dest >> 8
	STA dst+1
	;
	LDA #end_ & 255		; start comparing from end...
	STA ptr
	LDA #end_ >> 8
	STA ptr+1
	;
	JSR dec_ptr		; non-inclusive, so back 1 byte
	;
loop_beg
	LDA ptr			; reached beg?
	CMP #(beg_-1) & 255
	BNE b1
	LDA ptr+1
	CMP #(beg_-1) >> 8
	BNE b1
	;
	LDA #$45		; happy end
stop	STA $FF19
	BNE *
	
b1	LDY #$00		; reset length each time
	STY len
	;
	LDA (ptr),y
	STA curr		; get current byte
	;
	JSR dec_ptr
	;
	LDA curr
	CMP (ptr),y		; same as prev?
	BNE diff
	;
	; ---
count_length
	INC len
	;
	JSR dec_ptr
	LDA curr
	CMP (ptr),y		; keep going back
	BEQ count_length
	;
	LDA flag
	JSR store
	LDA len
	JSR store
diff	LDA curr
	JSR store
	;
	JMP loop_beg
	
inc_ptr
	LDA ptr
	CLC
	ADC #$01
	STA ptr
	BCC *+4
	INC ptr+1
	RTS
	
dec_ptr
	LDA ptr
	BNE *+4
	DEC ptr+1
	DEC ptr
	RTS  
	
store
	LDY #$00
	STA (dst),y
dec_dst
	LDA dst
	BNE *+4
	DEC dst+1
	DEC dst
	RTS
;[eof]